org.eclipse.ecf.core.util

## Class Trace

- java.lang.Object
- - org.eclipse.ecf.core.util.Trace

    public class Trace
    extends Object

A utility for tracing debug information. Provides a simple interface for filtering and generating trace output.

### Field Summary

Fields
`protected static String` `LABEL_NEW_VALUE` Label indicating new value.
`protected static String` `LABEL_OLD_VALUE` Label indicating old value.
`protected static String` `PARENTHESIS_CLOSE` String containing a close parenthesis.
`protected static String` `PARENTHESIS_OPEN` String containing an open parenthesis.
`protected static String` `PREFIX_CATCHING` Prefix for tracing the catching of throwables.
`protected static String` `PREFIX_CHANGING` Prefix for tracing the changing of values.
`protected static String` `PREFIX_ENTERING` Prefix for tracing the entering of methods.
`protected static String` `PREFIX_EXITING` Prefix for tracing the exiting of methods.
`protected static String` `PREFIX_THROWING` Prefix for tracing the throwing of throwables.
`protected static String` `PREFIX_TRACING` Prefix for tracing the changing of values.
`protected static String` `SEPARATOR_METHOD` Separator for methods.
`protected static String` `SEPARATOR_PARAMETER` Separator for parameters.
`protected static String` `SEPARATOR_RETURN` Separator for return values.
`protected static String` `SEPARATOR_SPACE` Separator containing a space.
`protected static String` `TRACE_STR` String containing TRACE

### Method Summary

All Methods Static Methods Concrete Methods
`static void` `catching(String pluginId, String option, Class clazz, String methodName, Throwable throwable)` Traces the catching of the specified throwable in the specified method of the specified class.
`static void` `changing(String pluginId, String option, Class clazz, String methodName, String valueDescription, Object oldValue, Object newValue)`
`static void` `changing(String pluginId, String option, String valueDescription, Object oldValue, Object newValue)` Traces the changing of a value.
`static void` `entering(String pluginId, String option, Class clazz, String methodName)` Traces the entering into the specified method of the specified class.
`static void` `entering(String pluginId, String option, Class clazz, String methodName, Object parameter)` Traces the entering into the specified method of the specified class, with the specified parameter.
`static void` `entering(String pluginId, String option, Class clazz, String methodName, Object[] parameters)` Traces the entering into the specified method of the specified class, with the specified parameters.
`static void` `exiting(String pluginId, String option, Class clazz, String methodName)` Traces the exiting from the specified method of the specified class.
`static void` `exiting(String pluginId, String option, Class clazz, String methodName, Object returnValue)` Traces the exiting from the specified method of the specified class, with the specified return value.
`static String` `getArgumentsString(Object[] arguments)` Retrieves a textual representation of the specified arguments.
`static String` `getArgumentString(Object argument)` Retrieves a textual representation of the specified argument.
`protected static String` `getTimeString()` Get date and time string
`protected static boolean` `shouldTrace(String pluginId)` Retrieves a Boolean value indicating whether tracing is enabled for the specified plug-in.
`static boolean` `shouldTrace(String pluginId, String option)` Retrieves a Boolean value indicating whether tracing is enabled for the specified debug option of the specified plug-in.
`protected static boolean` `shouldTrace0(String option)`
`static void` `throwing(String pluginId, String option, Class clazz, String methodName, Throwable throwable)` Traces the throwing of the specified throwable from the specified method of the specified class.
`protected static void` `trace(String message)` Traces the specified message.
`static void` `trace(String pluginId, String message)` Traces the specified message from the specified plug-in.
`static void` `trace(String pluginId, String option, Class clazz, String methodName, String message)` Traces the specified message from the specified plug-in for the specified debug option.
`static void` `trace(String pluginId, String option, String message)` Traces the specified message from the specified plug-in for the specified debug option.

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Field Detail

#### PARENTHESIS_OPEN

    protected static final String PARENTHESIS_OPEN

String containing an open parenthesis.

See Also:
  Constant Field Values

#### PARENTHESIS_CLOSE

    protected static final String PARENTHESIS_CLOSE

String containing a close parenthesis.

See Also:
  Constant Field Values

#### TRACE_STR

    protected static final String TRACE_STR

String containing TRACE

See Also:
  Constant Field Values

#### PREFIX_TRACING

    protected static final String PREFIX_TRACING

Prefix for tracing the changing of values.

See Also:
  Constant Field Values

#### PREFIX_CHANGING

    protected static final String PREFIX_CHANGING

Prefix for tracing the changing of values.

See Also:
  Constant Field Values

#### PREFIX_CATCHING

    protected static final String PREFIX_CATCHING

Prefix for tracing the catching of throwables.

See Also:
  Constant Field Values

#### PREFIX_THROWING

    protected static final String PREFIX_THROWING

Prefix for tracing the throwing of throwables.

See Also:
  Constant Field Values

#### PREFIX_ENTERING

    protected static final String PREFIX_ENTERING

Prefix for tracing the entering of methods.

See Also:
  Constant Field Values

#### PREFIX_EXITING

    protected static final String PREFIX_EXITING

Prefix for tracing the exiting of methods.

See Also:
  Constant Field Values

#### SEPARATOR_METHOD

    protected static final String SEPARATOR_METHOD

Separator for methods.

See Also:
  Constant Field Values

#### SEPARATOR_PARAMETER

    protected static final String SEPARATOR_PARAMETER

Separator for parameters.

See Also:
  Constant Field Values

#### SEPARATOR_RETURN

    protected static final String SEPARATOR_RETURN

Separator for return values.

See Also:
  Constant Field Values

#### SEPARATOR_SPACE

    protected static final String SEPARATOR_SPACE

Separator containing a space.

See Also:
  Constant Field Values

#### LABEL_OLD_VALUE

    protected static final String LABEL_OLD_VALUE

Label indicating old value.

See Also:
  Constant Field Values

#### LABEL_NEW_VALUE

    protected static final String LABEL_NEW_VALUE

Label indicating new value.

See Also:
  Constant Field Values

### Method Detail

#### shouldTrace

    protected static boolean shouldTrace(String pluginId)

Retrieves a Boolean value indicating whether tracing is enabled for the specified plug-in.

Parameters:
  `pluginId` - The symbolic plugin id for which to determine trace enablement.
Returns:
  Whether tracing is enabled for the plug-in.

#### shouldTrace0

    protected static boolean shouldTrace0(String option)

#### shouldTrace

    public static boolean shouldTrace(String pluginId,
                                      String option)

Retrieves a Boolean value indicating whether tracing is enabled for the specified debug option of the specified plug-in.

Parameters:
  `pluginId` - The plug-in for which to determine trace enablement.
  `option` - The debug option for which to determine trace enablement.
Returns:
  Whether tracing is enabled for the debug option of the plug-in.

#### getArgumentString

    public static String getArgumentString(Object argument)

Retrieves a textual representation of the specified argument.

Parameters:
  `argument` - The argument for which to retrieve a textual representation.
Returns:
  A textual representation of the specified argument.

#### getArgumentsString

    public static String getArgumentsString(Object[] arguments)

Retrieves a textual representation of the specified arguments.

Parameters:
  `arguments` - The arguments for which to retrieve a textual representation.
Returns:
  A textual representation of the specified arguments.

#### trace

    protected static void trace(String message)

Traces the specified message.

Parameters:
  `message` - The message to be traced.

#### getTimeString

    protected static String getTimeString()

Get date and time string

Returns:
  String with current date and time

#### trace

    public static void trace(String pluginId,
                             String message)

Traces the specified message from the specified plug-in.

Parameters:
  `pluginId` - The plug-in from which to trace.
  `message` - The message to be traced.

#### trace

    public static void trace(String pluginId,
                             String option,
                             String message)

Traces the specified message from the specified plug-in for the specified debug option.

Parameters:
  `pluginId` - The plug-in from which to trace.
  `option` - The debug option for which to trace.
  `message` - The message to be traced.

#### trace

    public static void trace(String pluginId,
                             String option,
                             Class clazz,
                             String methodName,
                             String message)

Traces the specified message from the specified plug-in for the specified debug option.

Parameters:
  `pluginId` - The plug-in from which to trace.
  `option` - The debug option for which to trace.
  `clazz` - The class whose method is being entered.
  `methodName` - The name of method that is being entered.
  `message` - The message to be traced.

#### changing

    public static void changing(String pluginId,
                                String option,
                                String valueDescription,
                                Object oldValue,
                                Object newValue)

Traces the changing of a value.

Parameters:
  `pluginId` - The plug-in from which to trace.
  `option` - The debug option for which to trace.
  `valueDescription` - The description of the value which is changing.
  `oldValue` - The old value.
  `newValue` - The new value.

#### changing

    public static void changing(String pluginId,
                                String option,
                                Class clazz,
                                String methodName,
                                String valueDescription,
                                Object oldValue,
                                Object newValue)

Parameters:
  `pluginId` - The plug-in from which to trace.
  `option` - The debug option for which to trace.
  `clazz` - The class in which the value is changing.
  `methodName` - The name of the method in which the value is changing.
  `valueDescription` - The description of the value which is changing.
  `oldValue` - The old value.
  `newValue` - The new value.

#### catching

    public static void catching(String pluginId,
                                String option,
                                Class clazz,
                                String methodName,
                                Throwable throwable)

Traces the catching of the specified throwable in the specified method of the specified class.

Parameters:
  `pluginId` - The plug-in from which to trace.
  `option` - The debug option for which to trace.
  `clazz` - The class in which the throwable is being caught.
  `methodName` - The name of the method in which the throwable is being caught.
  `throwable` - The throwable that is being caught.

#### throwing

    public static void throwing(String pluginId,
                                String option,
                                Class clazz,
                                String methodName,
                                Throwable throwable)

Traces the throwing of the specified throwable from the specified method of the specified class.

Parameters:
  `pluginId` - The plug-in from which to trace.
  `option` - The debug option for which to trace.
  `clazz` - The class from which the throwable is being thrown.
  `methodName` - The name of the method from which the throwable is being thrown.
  `throwable` - The throwable that is being thrown.

#### entering

    public static void entering(String pluginId,
                                String option,
                                Class clazz,
                                String methodName)

Traces the entering into the specified method of the specified class.

Parameters:
  `pluginId` - The plug-in from which to trace.
  `option` - The debug option for which to trace.
  `clazz` - The class whose method is being entered.
  `methodName` - The name of method that is being entered.

#### entering

    public static void entering(String pluginId,
                                String option,
                                Class clazz,
                                String methodName,
                                Object parameter)

Traces the entering into the specified method of the specified class, with the specified parameter.

Parameters:
  `pluginId` - The plug-in from which to trace.
  `option` - The debug option for which to trace.
  `clazz` - The class whose method is being entered.
  `methodName` - The name of method that is being entered.
  `parameter` - The parameter to the method being entered.

#### entering

    public static void entering(String pluginId,
                                String option,
                                Class clazz,
                                String methodName,
                                Object[] parameters)

Traces the entering into the specified method of the specified class, with the specified parameters.

Parameters:
  `pluginId` - The plug-in from which to trace.
  `option` - The debug option for which to trace.
  `clazz` - The class whose method is being entered.
  `methodName` - The name of method that is being entered.
  `parameters` - The parameters to the method being entered.

#### exiting

    public static void exiting(String pluginId,
                               String option,
                               Class clazz,
                               String methodName)

Traces the exiting from the specified method of the specified class.

Parameters:
  `pluginId` - The plug-in from which to trace.
  `option` - The debug option for which to trace.
  `clazz` - The class whose method is being exited.
  `methodName` - The name of method that is being exited.

#### exiting

    public static void exiting(String pluginId,
                               String option,
                               Class clazz,
                               String methodName,
                               Object returnValue)

Traces the exiting from the specified method of the specified class, with the specified return value.

Parameters:
  `pluginId` - The plug-in from which to trace.
  `option` - The debug option for which to trace.
  `clazz` - The class whose method is being exited.
  `methodName` - The name of method that is being exited.
  `returnValue` - The return value of the method being exited.